diff --git a/lib/hive/commands/setup/qmd_installer.rb b/lib/hive/commands/setup/qmd_installer.rb
new file mode 100644
index 00000000..300603d2
--- /dev/null
+++ b/lib/hive/commands/setup/qmd_installer.rb
@@ -0,0 +1,93 @@
+require "fileutils"
+require "open3"
+require "timeout"
+
+require "hive"
+require "hive/paths"
+
+module Hive
+  module Commands
+    class Setup
+      # The Ruby form of install.sh's qmd contract. It owns only the managed
+      # XDG prefix and never replaces a pre-existing user qmd executable/link.
+      class QmdInstaller
+        Result = Data.define(:status, :path, :message)
+        PACKAGE = "@tobilu/qmd".freeze
+
+        def initialize(which: nil, runner: nil, package: PACKAGE, timeout: 120)
+          @which = which || method(:which)
+          @runner = runner || method(:run)
+          @package = package
+          @timeout = timeout
+        end
+
+        def call
+          npm = @which.call("npm")
+          unless npm
+            return Result.new(:needs_attention, managed_bin,
+                              "qmd needs Node.js/npm; install Node.js/npm, then run `hive setup`")
+          end
+
+          install = [ npm, "install", "--global", "--prefix", managed_home, "--no-audit", "--no-fund", @package ]
+          return failure("npm install failed") unless invoke(install)
+
+          # A Node upgrade can invalidate better-sqlite3 after qmd itself is
+          # present. Best effort here mirrors the installer; the following
+          # executable probe is the authoritative success check.
+          invoke([ npm, "rebuild", "--global", "--prefix", managed_home, "better-sqlite3" ])
+          return failure("qmd executable was not created") unless File.file?(managed_bin) && File.executable?(managed_bin)
+          return failure("qmd failed its version probe") unless invoke([ managed_bin, "--version" ])
+
+          message = link_managed_bin
+          Result.new(:installed, managed_bin, message || "qmd installed at #{managed_bin}")
+        rescue Timeout::Error
+          failure("qmd provisioning timed out")
+        end
+
+        def managed_home
+          File.join(Hive::Paths.data_home, "qmd")
+        end
+
+        def managed_bin
+          File.join(managed_home, "bin", "qmd")
+        end
+
+        private
+
+        def failure(reason)
+          Result.new(:needs_attention, managed_bin,
+                     "#{reason}; run `npm install --global --prefix #{managed_home} #{@package}` after fixing Node/npm")
+        end
+
+        def invoke(argv)
+          @runner.call(argv, timeout: @timeout).fetch(:ok, false)
+        end
+
+        def link_managed_bin
+          link = File.join(Hive::Paths.bin_home, "qmd")
+          FileUtils.mkdir_p(File.dirname(link))
+          if File.exist?(link) || File.symlink?(link)
+            existing = File.realpath(link) rescue File.expand_path(link)
+            managed = File.realpath(managed_bin) rescue File.expand_path(managed_bin)
+            return "existing qmd at #{link}; leaving it unchanged (Hive-managed qmd is #{managed_bin})" unless existing == managed
+          end
+          FileUtils.ln_sf(managed_bin, link)
+          nil
+        end
+
+        def which(name)
+          ENV.fetch("PATH", "").split(File::PATH_SEPARATOR).each do |dir|
+            candidate = File.join(dir, name)
+            return candidate if File.file?(candidate) && File.executable?(candidate)
+          end
+          nil
+        end
+
+        def run(argv, timeout:)
+          stdout, stderr, status = Timeout.timeout(timeout) { Open3.capture3(*argv) }
+          { ok: status.success?, stdout: stdout, stderr: stderr }
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/setup/web_provisioner.rb b/lib/hive/commands/setup/web_provisioner.rb
new file mode 100644
index 00000000..e3a822ec
--- /dev/null
+++ b/lib/hive/commands/setup/web_provisioner.rb
@@ -0,0 +1,102 @@
+require "fileutils"
+require "json"
+
+require "hive"
+require "hive/web/runtime_layout"
+
+module Hive
+  module Commands
+    class Setup
+      # Stages the packaged Rails application into a writable XDG runtime.
+      # This deliberately has no implicit path from `hive web`: network/native
+      # setup is an explicit `hive setup` repair operation, never a side effect
+      # of a long-lived service starting after reboot.
+      class WebProvisioner
+        Result = Data.define(:status, :app_dir, :message)
+
+        BUNDLER_ENV_KEYS = %w[
+          BUNDLE_GEMFILE BUNDLE_PATH BUNDLE_BIN_PATH BUNDLE_APP_CONFIG
+          BUNDLE_WITH BUNDLE_WITHOUT BUNDLE_DEPLOYMENT BUNDLE_FROZEN
+        ].freeze
+
+        def initialize(layout: Hive::Web::RuntimeLayout.new, hive_gem_root: nil, runner: nil)
+          @layout = layout
+          @hive_gem_root = File.expand_path(hive_gem_root || @layout.package_root)
+          @runner = runner || method(:run_command)
+        end
+
+        attr_reader :layout
+
+        def call
+          raise Hive::Error, missing_payload_message unless layout.source_available?
+
+          identity = layout.identity
+          return Result.new(:unchanged, layout.app_dir, "matching web runtime already provisioned") if layout.completed?(identity)
+
+          staging = layout.staging_dir
+          FileUtils.rm_rf(staging)
+          begin
+            FileUtils.mkdir_p(layout.runtime_root)
+            FileUtils.cp_r(File.join(layout.source_app_dir, "."), staging)
+            FileUtils.mkdir_p(layout.storage_path)
+            FileUtils.mkdir_p(File.join(staging, "tmp"))
+            FileUtils.mkdir_p(File.join(staging, "log"))
+
+            env = runtime_env(staging)
+            run!(env, staging, [ "bundle", "install", "--deployment", "--without", "development", "test" ], "bundle install")
+            run!(env, staging, [ "bin/rails", "assets:precompile" ], "asset precompile")
+            run!(env, staging, [ "bin/rails", "db:prepare" ], "db:prepare")
+
+            File.write(File.join(staging, Hive::Web::RuntimeLayout::MANIFEST_FILE), JSON.pretty_generate(
+              "identity" => identity,
+              "created_at" => Time.now.utc.iso8601
+            ))
+            layout.promote!(staging)
+            layout.cleanup_previous!
+            Result.new(:provisioned, layout.app_dir, "web runtime provisioned")
+          rescue StandardError
+            FileUtils.rm_rf(staging)
+            raise
+          end
+        end
+
+        # Public for unit tests and for the service command, which must start
+        # with exactly the same XDG/bundle contract as setup used.
+        def runtime_env(app_dir = layout.app_dir)
+          inherited = ENV.to_h.reject { |key, _| BUNDLER_ENV_KEYS.include?(key) }
+          inherited.merge(
+            "BUNDLE_PATH" => layout.bundle_path,
+            "BUNDLE_DISABLE_SHARED_GEMS" => "true",
+            "BUNDLE_DEPLOYMENT" => "true",
+            "HIVE_WEB_HIVE_GEM_PATH" => @hive_gem_root,
+            "HIVE_WEB_STORAGE_DIR" => layout.storage_path,
+            # Backward-compatible aliases keep hivebox and development tools
+            # working while Rails moves to neutral variable names.
+            "HIVEBOX_STORAGE_DIR" => layout.storage_path,
+            "BUNDLE_GEMFILE" => nil,
+            "HIVE_WEB_RUNTIME_DIR" => app_dir
+          ).compact
+        end
+
+        private
+
+        def run!(env, chdir, argv, label)
+          return if @runner.call(env, chdir, argv)
+
+          raise Hive::Error, "hive setup: web #{label} failed; run `hive setup` again after fixing the reported dependency"
+        end
+
+        def run_command(env, chdir, argv)
+          # `unsetenv_others: false` preserves normal CLI PATH and XDG values;
+          # runtime_env has explicitly removed every Bundler redirect key.
+          system(env, *argv, chdir: chdir)
+        end
+
+        def missing_payload_message
+          "hive setup: packaged Rails web source was not found at #{layout.source_app_dir}. " \
+            "Reinstall this Hive version; `hive web` cannot provision a missing package payload."
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/uninstall.rb b/lib/hive/commands/uninstall.rb
index 57f319a2..c9b63431 100644
--- a/lib/hive/commands/uninstall.rb
+++ b/lib/hive/commands/uninstall.rb
@@ -21,6 +21,7 @@ module Hive
         projects = registered_projects
         deregister_daemon
         deregister_bot
+        deregister_web
         remove_user_config_and_cache
         remove_data_versions
         remove_user_symlinks
@@ -54,6 +55,14 @@ module Hive
         deregister_unit(Hive::Commands::Bot::ServiceInstaller.new(host_os: @host_os))
       end
 
+      def deregister_web
+        require "hive/commands/web/service_installer"
+        config = Hive::Config.load_global_web
+        deregister_unit(Hive::Commands::Web::ServiceInstaller.new(config: config, host_os: @host_os))
+      rescue Hive::ConfigError => e
+        @output.puts "hive: warning: could not read web config (#{e.message}); skipping web unit cleanup"
+      end
+
       # Deregister a per-user autostart unit using the installer's OWN
       # identity (`target_path` / `service_name`) as the single source of
       # truth, so install and uninstall can never drift on paths or names —
@@ -149,7 +158,7 @@ module Hive
         return unless File.directory?(data_home)
 
         Dir.children(data_home).each do |entry|
-          next unless entry.start_with?("v") || entry =~ /\A\d+\.\d+\.\d+/
+          next unless entry == "web" || entry.start_with?("v") || entry =~ /\A\d+\.\d+\.\d+/
 
           FileUtils.rm_rf(File.join(data_home, entry))
         end
diff --git a/lib/hive/commands/web.rb b/lib/hive/commands/web.rb
index eb3cd40f..c96d3cd9 100644
--- a/lib/hive/commands/web.rb
+++ b/lib/hive/commands/web.rb
@@ -1,27 +1,43 @@
 require "hive/config"
 require "hive/web/session_secret"
+require "hive/web/runtime_layout"
+require "hive/web/auth_policy"
+require "hive/invoked_binary"
 
 module Hive
   module Commands
-    # Boots the hivebox web UI — a Rails app living in web/ at the repo root
-    # (shipped in the Docker image at /app/web). hive itself stays a plain
-    # CLI gem; the web tier is only supported where the Rails app and its
-    # bundle exist: the hivebox container or a source checkout.
+    # Boots Hive's Rails UI. Docker retains HIVEBOX_WEB_APP_DIR and its /data
+    # contract; installed CLIs use the matching, setup-provisioned XDG runtime.
     class Web
-      def initialize(bind: nil, port: nil)
+      BUNDLER_ENV_KEYS = %w[
+        BUNDLE_GEMFILE BUNDLE_PATH BUNDLE_BIN_PATH BUNDLE_APP_CONFIG
+        BUNDLE_WITH BUNDLE_WITHOUT BUNDLE_DEPLOYMENT BUNDLE_FROZEN
+      ].freeze
+
+      def initialize(bind: nil, port: nil, auth: nil, unsafe_no_auth: false, action: nil, force: false)
         @bind = bind
         @port = port
+        @auth = auth
+        @unsafe_no_auth = unsafe_no_auth
+        @action = action
+        @force = force
       end
 
       def call
         cfg = Hive::Config.load_global_web
         bind = @bind || cfg.fetch("bind")
         port = (@port || cfg.fetch("port")).to_i
+        policy = Hive::Web::AuthPolicy.new(
+          bind: bind, configured_mode: @auth || ENV["HIVE_WEB_AUTH"] || cfg.fetch("auth"), unsafe_no_auth: @unsafe_no_auth
+        )
+        raise Hive::Error, policy.refusal_message unless policy.allowed?
+        warn "hive web: WARNING #{policy.refusal_message.delete_prefix('hive web: ')}" if policy.unsafe?
+        return manage_service(cfg) if @action
         app_dir = rails_app_dir
         unless app_dir
           warn "hive web: the hivebox web app (web/) was not found. " \
-               "Run from the hivebox Docker image or a source checkout, " \
-               "or point HIVEBOX_WEB_APP_DIR at the Rails app."
+               "Run `hive setup` to provision this Hive version, or point " \
+               "HIVEBOX_WEB_APP_DIR at a Docker-compatible Rails app."
           exit 1
         end
 
@@ -34,44 +50,112 @@ module Hive
           # sessions (the file lives on the /data mount).
           "SECRET_KEY_BASE" => ENV["SECRET_KEY_BASE"] ||
             Hive::Web::SessionSecret.load_or_create(cfg.fetch("session_secret_file")),
+          "HIVE_WEB_ORIGIN" => cfg.fetch("origin"),
           "HIVEBOX_ORIGIN" => cfg.fetch("origin"),
           # The solid_cable/cache/queue sqlite files must survive image
           # upgrades — keep them in state_home (on /data in the container),
           # not in the app dir.
-          "HIVEBOX_STORAGE_DIR" => ENV["HIVEBOX_STORAGE_DIR"] ||
-            File.join(Hive::Paths.state_home, "web-storage"),
-          "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile")
+          "HIVE_WEB_STORAGE_DIR" => ENV["HIVE_WEB_STORAGE_DIR"] || ENV["HIVEBOX_STORAGE_DIR"] ||
+            runtime_layout.storage_path,
+          "HIVEBOX_STORAGE_DIR" => ENV["HIVE_WEB_STORAGE_DIR"] || ENV["HIVEBOX_STORAGE_DIR"] ||
+            runtime_layout.storage_path,
+          "HIVE_WEB_BIND" => bind,
+          "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile"),
+          "HIVE_WEB_HIVE_GEM_PATH" => runtime_layout.package_root,
+          "HIVE_BIN" => Hive::InvokedBinary.path,
+          "HIVE_WEB_AUTH" => policy.effective_mode
         }
-        FileUtils.mkdir_p(env.fetch("HIVEBOX_STORAGE_DIR"))
+        if provisioned_runtime?(app_dir)
+          env["BUNDLE_PATH"] = runtime_layout.bundle_path
+          env["BUNDLE_DEPLOYMENT"] = "true"
+          env["BUNDLE_DISABLE_SHARED_GEMS"] = "true"
+        end
+        FileUtils.mkdir_p(env.fetch("HIVE_WEB_STORAGE_DIR"))
 
         Dir.chdir(app_dir) do
           # Idempotent: creates/migrates the solid-stack sqlite databases on
           # first boot, no-ops afterwards. Array form — no shell involved.
           # Typed error so a persistent failure surfaces as guidance, not a
           # raw backtrace looping every 5s under the container supervisor.
-          unless system(env, "bin/rails", "db:prepare")
+          unless system(sanitized_env(env), "bin/rails", "db:prepare")
             raise Hive::Error,
                   "hive web: db:prepare failed — check that " \
-                  "#{env.fetch("HIVEBOX_STORAGE_DIR")} is writable (the /data mount) " \
+                  "#{env.fetch("HIVE_WEB_STORAGE_DIR")} is writable " \
                   "and that the web bundle is installed (cd #{app_dir} && bundle install)"
           end
           puts "hive web: listening on http://#{bind}:#{port}"
           # Replace this process with the Rails server (array form, env hash;
           # Kernel#exec never touches a shell when given an argv list).
-          Kernel.exec env, "bin/rails", "server", "-b", bind, "-p", port.to_s
+          Kernel.exec sanitized_env(env), "bin/rails", "server", "-b", bind, "-p", port.to_s
         end
       end
 
       private
 
+      def manage_service(cfg)
+        require "hive/commands/web/service_installer"
+        installer = Hive::Commands::Web::ServiceInstaller.new(
+          config: cfg, unsafe_no_auth: @unsafe_no_auth, binary_path: Hive::InvokedBinary.path
+        )
+        outcome =
+          case @action
+          when "install" then installer.install!(autostart: false, force: @force)
+          when "start" then installer.start!
+          else
+            raise Hive::InvalidTaskPath, "hive web: unknown action #{@action.inspect} (expected: install or start)"
+          end
+        installer.messages.each { |message| warn "hive: #{message}" }
+        if outcome.drifted?
+          raise Hive::Error, "web unit at #{installer.target_path} differs from the managed template; " \
+                             "run `hive web install --force` to back it up and repair it"
+        end
+        raise Hive::Error, "hive web #{@action}: service manager failed; see the command above" if outcome.failed?
+
+        case @action
+        when "install" then puts "hive web: installed unit at #{installer.target_path}" unless outcome.kind == :unchanged
+        when "start"
+          if outcome.kind == :autostart_unavailable
+            puts "hive web: unit is installed but systemd-user is unavailable; run `hive web` in the foreground"
+          else
+            puts "hive web: started #{installer.service_name}"
+          end
+        end
+        outcome
+      end
+
       def rails_app_dir
         candidates = [
           ENV["HIVEBOX_WEB_APP_DIR"],
+          ENV["HIVE_WEB_APP_DIR"],
+          provisioned_app_dir,
           File.expand_path("../../../web", __dir__)
         ].compact
         candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
       end
 
+      def runtime_layout
+        @runtime_layout ||= Hive::Web::RuntimeLayout.new
+      end
+
+      def provisioned_app_dir
+        identity = runtime_layout.identity
+        runtime_layout.app_dir if runtime_layout.completed?(identity)
+      rescue SystemCallError
+        nil
+      end
+
+      def provisioned_runtime?(app_dir)
+        File.expand_path(app_dir) == runtime_layout.app_dir
+      end
+
+      # A parent Bundler context (especially CI) can otherwise redirect a
+      # service into an unrelated Gemfile/bundle. nil explicitly unsets these
+      # keys for Process.spawn/exec while retaining safe shell/XDG variables.
+      def sanitized_env(env)
+        inherited = BUNDLER_ENV_KEYS.to_h { |key| [ key, nil ] }
+        inherited.merge(env)
+      end
+
       # Rails' production host authorization is inactive by default — the box
       # assumes a trusted reverse proxy validates Host, exactly like the
       # pre-Rails posture. Binding a public interface without that proxy
diff --git a/lib/hive/commands/web/service_installer.rb b/lib/hive/commands/web/service_installer.rb
new file mode 100644
index 00000000..28c071b0
--- /dev/null
+++ b/lib/hive/commands/web/service_installer.rb
@@ -0,0 +1,76 @@
+require "cgi"
+require "shellwords"
+
+require "hive/commands/service_installer/base"
+require "hive/paths"
+require "hive/web/auth_policy"
+
+module Hive
+  module Commands
+    class Web
+      # Native unit renderer for the Rails process. It intentionally does not
+      # share a process, PID file, or lifecycle with hive-daemon.
+      class ServiceInstaller < Hive::Commands::ServiceInstaller::Base
+        def initialize(config:, unsafe_no_auth: false, **kwargs)
+          @config = config
+          @unsafe_no_auth = unsafe_no_auth
+          @auth = Hive::Web::AuthPolicy.new(
+            bind: config.fetch("bind"), configured_mode: config.fetch("auth"), unsafe_no_auth: unsafe_no_auth
+          )
+          super(**kwargs)
+        end
+
+        def service_name = "hive-web"
+        def cli_label = "web"
+        def service_noun = "web service"
+        def unit_noun = "web unit"
+
+        def target_path
+          case platform
+          when :macos then File.join(@home, "Library/LaunchAgents/local.hive-web.plist")
+          when :linux then File.join(@home, ".config/systemd/user/hive-web.service")
+          end
+        end
+
+        private
+
+        def render_systemd
+          template = File.read(File.expand_path("../../../../examples/systemd/hive-web.service", __dir__))
+          escaped = Shellwords.escape(resolved_binary)
+          template
+            .sub(/^ExecStart=.*$/, "ExecStart=#{escaped} web#{unsafe_flag}")
+            .sub(/^Environment=PATH=.*$/, build_path_line)
+            .sub("Environment=HIVE_WEB_ENVIRONMENT_PLACEHOLDER", systemd_environment.join("\n"))
+        end
+
+        def render_launchd
+          template = File.read(File.expand_path("../../../../examples/launchd/hive-web.plist", __dir__))
+          binary = resolved_binary
+          template
+            .gsub("/Users/YOU/.local/bin/hive", CGI.escapeHTML(binary))
+            .gsub("/Users/YOU/Library/Logs", CGI.escapeHTML(File.join(@home, "Library/Logs")))
+            .gsub("<!-- HIVE_WEB_UNSAFE -->", unsafe_flag.empty? ? "" : "<string>--unsafe-no-auth</string>")
+            .gsub("<!-- HIVE_WEB_ENVIRONMENT -->", launchd_environment)
+        end
+
+        def unsafe_flag
+          @auth.unsafe? && @unsafe_no_auth ? " --unsafe-no-auth" : ""
+        end
+
+        def service_environment
+          values = hive_service_environment
+          values["HIVE_WEB_AUTH"] = @auth.effective_mode
+          values
+        end
+
+        def systemd_environment
+          systemd_environment_lines(service_environment)
+        end
+
+        def launchd_environment
+          launchd_environment_entries(service_environment)
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index da8bd31a..f3c4ff17 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -7,6 +7,7 @@ require "hive/babysitter/interval"
 require "hive/permission_scope"
 require "hive/paths"
 require "hive/screenote/oauth_client"
+require "hive/web/auth_policy"
 
 module Hive
   module Config
@@ -372,6 +373,7 @@ module Hive
       "web" => {
         "bind" => "127.0.0.1",
         "port" => 4567,
+        "auth" => "auto",
         "origin" => "http://127.0.0.1:4567",
         "github" => {
           "owner" => nil,
@@ -2271,6 +2273,12 @@ module Hive
               "web.port in #{describe_source(source_path)} must be an integer between 1 and 65535"
       end
 
+      auth = web["auth"]
+      unless Hive::Web::AuthPolicy::MODES.include?(auth)
+        raise ConfigError,
+              "web.auth in #{describe_source(source_path)} must be one of #{Hive::Web::AuthPolicy::MODES.join(', ')}"
+      end
+
       origin = web["origin"]
       unless origin.is_a?(String) && origin.match?(%r{\Ahttps?://})
         raise ConfigError,
diff --git a/lib/hive/daemon/health.rb b/lib/hive/daemon/health.rb
new file mode 100644
index 00000000..2cd2773a
--- /dev/null
+++ b/lib/hive/daemon/health.rb
@@ -0,0 +1,91 @@
+require "hive"
+require "hive/invoked_binary"
+require "hive/paths"
+require "hive/pid_file"
+
+module Hive
+  module Daemon
+    # Read-only daemon identity comparison shared by CLI status, setup, and
+    # Rails. It intentionally never signals a PID: legacy/unknown ownership
+    # is diagnostic information, not authority to kill a process.
+    class Health
+      Result = Data.define(:state, :payload, :mismatches, :remediation, :service_state) do
+        def healthy?
+          state == :match
+        end
+      end
+
+      class Reader
+        include Hive::PidFile
+
+        def initialize(path)
+          @path = path
+        end
+
+        def pid_file
+          @path
+        end
+      end
+
+      def self.current(service_state: nil)
+        reader = Reader.new(File.join(Hive::Paths.state_home, ".daemon.pid"))
+        new(
+          payload: reader.read_pid_file_payload,
+          current_binary: ENV["HIVE_BIN"] || Hive::InvokedBinary.path,
+          current_version: Hive::VERSION,
+          process_alive: ->(pid) { reader.pid_alive?(pid) },
+          process_owned: ->(payload, pid) { reader.pid_owned_by_us?(payload, pid) },
+          service_state: service_state
+        ).call
+      end
+
+      def initialize(payload:, current_binary:, current_version:, process_alive:, process_owned:, service_state: nil)
+        @payload = payload
+        @current_binary = canonical_path(current_binary)
+        @current_version = current_version.to_s
+        @process_alive = process_alive
+        @process_owned = process_owned
+        @service_state = service_state
+      end
+
+      def call
+        return result(:stopped, "Start it with `hive daemon start` or `hive daemon install`.") unless live_payload?
+        return result(:unknown, "Daemon identity is from an older Hive version; run `hive daemon install --force` to repair it.") unless identity_complete?
+
+        mismatches = []
+        mismatches << "invoked_binary" unless canonical_path(@payload["invoked_binary"]) == @current_binary
+        mismatches << "hive_version" unless @payload["hive_version"].to_s == @current_version
+        return Result.new(:mismatch, @payload, mismatches, "Run `hive daemon install --force` to repair the daemon wrapper/version.", @service_state) unless mismatches.empty?
+        return result(:unmanaged, "Daemon is running without a managed unit; run `hive daemon install`.") if @service_state&.fetch("service_installed", nil) == false
+
+        result(:match, "Daemon wrapper and version match this Hive CLI.")
+      end
+
+      private
+
+      def live_payload?
+        pid = @payload && @payload["pid"]
+        pid.is_a?(Integer) && pid.positive? && @process_alive.call(pid) && @process_owned.call(@payload, pid)
+      rescue SystemCallError
+        false
+      end
+
+      def identity_complete?
+        @payload["invoked_binary"].is_a?(String) && !@payload["invoked_binary"].empty? &&
+          @payload["hive_version"].is_a?(String) && !@payload["hive_version"].empty?
+      end
+
+      def result(state, remediation)
+        Result.new(state, @payload, [], remediation, @service_state)
+      end
+
+      def canonical_path(path)
+        return nil if path.nil? || path.to_s.empty?
+
+        File.realpath(path)
+      rescue SystemCallError
+        File.expand_path(path)
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/repair.rb b/lib/hive/daemon/repair.rb
new file mode 100644
index 00000000..b07be8fc
--- /dev/null
+++ b/lib/hive/daemon/repair.rb
@@ -0,0 +1,42 @@
+require "hive"
+require "hive/commands/daemon/service_installer"
+require "hive/daemon/health"
+require "hive/invoked_binary"
+
+module Hive
+  module Daemon
+    # Controlled recovery for a stale *managed* daemon. The installer owns
+    # service-manager operations and backup semantics; this object only
+    # coordinates force-render → restart → identity observation.
+    class Repair
+      Result = Data.define(:status, :backup_path, :health, :message)
+
+      def initialize(installer: nil, health: nil, sleeper: ->(seconds) { sleep(seconds) }, timeout: 20)
+        @installer = installer || Hive::Commands::Daemon::ServiceInstaller.new(binary_path: Hive::InvokedBinary.path)
+        @health = health || -> { Hive::Daemon::Health.current(service_state: @installer.service_state) }
+        @sleeper = sleeper
+        @timeout = timeout
+      end
+
+      def call
+        outcome = @installer.install!(autostart: true, force: true)
+        unless outcome.success?
+          return Result.new(:failed, outcome.backup_path, @health.call,
+                            "daemon unit repair failed; see service-manager diagnostics")
+        end
+
+        deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + @timeout
+        loop do
+          state = @health.call
+          return Result.new(:repaired, outcome.backup_path, state, "daemon identity now matches") if state.healthy?
+          break if Process.clock_gettime(Process::CLOCK_MONOTONIC) >= deadline
+
+          @sleeper.call(0.2)
+        end
+        state = @health.call
+        Result.new(:failed, outcome.backup_path, state,
+                   "daemon unit was repaired but a matching daemon did not become healthy before timeout")
+      end
+    end
+  end
+end
diff --git a/lib/hive/pid_file.rb b/lib/hive/pid_file.rb
index 9c58113a..1afb8c72 100644
--- a/lib/hive/pid_file.rb
+++ b/lib/hive/pid_file.rb
@@ -57,13 +57,13 @@ module Hive
       nil
     end
 
-    def pid_file_payload(pid, start_time = nil)
+    def pid_file_payload(pid, start_time = nil, identity: {})
       start_time ||= Hive::Lock.process_start_time(pid)
       {
         "pid" => pid,
         "process_start_time" => start_time,
         "started_at" => Time.now.utc.iso8601
-      }
+      }.merge(identity)
     end
 
     def send_signal_safely(pid, signal)
diff --git a/lib/hive/web/auth_policy.rb b/lib/hive/web/auth_policy.rb
new file mode 100644
index 00000000..43ca0012
--- /dev/null
+++ b/lib/hive/web/auth_policy.rb
@@ -0,0 +1,50 @@
+require "ipaddr"
+
+module Hive
+  module Web
+    # Resolve access policy before Rails boots. Request Host headers are an
+    # attacker-controlled input and must never decide whether auth is skipped.
+    class AuthPolicy
+      MODES = %w[auto none github].freeze
+
+      def initialize(bind:, configured_mode:, unsafe_no_auth: false)
+        @bind = bind.to_s.strip
+        @configured_mode = configured_mode.to_s
+        @unsafe_no_auth = unsafe_no_auth
+      end
+
+      attr_reader :bind
+
+      def effective_mode
+        return @configured_mode unless @configured_mode == "auto"
+
+        loopback_bind? ? "none" : "github"
+      end
+
+      def allowed?
+        effective_mode != "none" || loopback_bind? || @unsafe_no_auth
+      end
+
+      def unsafe?
+        effective_mode == "none" && !loopback_bind?
+      end
+
+      def loopback_bind?
+        return true if bind.casecmp?("localhost")
+
+        address = IPAddr.new(bind)
+        address.loopback?
+      rescue IPAddr::InvalidAddressError
+        # DNS labels, wildcards, and malformed values fail closed. In
+        # particular, do not resolve a hostname here: its answer can change
+        # between setup and a managed service boot.
+        false
+      end
+
+      def refusal_message
+        "hive web: refusing auth=none on non-loopback bind #{bind.inspect}; " \
+          "choose web.auth=github or pass --unsafe-no-auth explicitly"
+      end
+    end
+  end
+end
